var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { computed, ref, nextTick, watch, defineComponent, useCssVars, openBlock, createBlock, Transition, withCtx, createElementBlock, normalizeClass, normalizeStyle, createCommentVNode, renderSlot, onBeforeUnmount, resolveComponent, Fragment, normalizeProps, guardReactiveProps, Teleport, createVNode, withDirectives, createElementVNode, vShow, shallowReactive, inject, renderList, resolveDynamicComponent, mergeProps } from "vue";
var main = "";
const convertToUnit = (str, unit = "px") => {
  if (str == null || str === "")
    return void 0;
  else if (isNaN(+str))
    return String(str);
  else
    return `${Number(str)}${unit}`;
};
const getZIndex = (el) => {
  if (!el || el.nodeType !== Node.ELEMENT_NODE)
    return 0;
  const index = parseInt(window.getComputedStyle(el).getPropertyValue("z-index"));
  if (!index)
    return getZIndex(el.parentNode);
  return index;
};
const useStackable = ({
  activeElSelector,
  stackMinZIndex = 0,
  isActive,
  content
}) => {
  const getMaxZIndex = (exclude = []) => {
    const zIndexes = [stackMinZIndex];
    const activeElements = document.querySelectorAll(activeElSelector);
    for (let index = 0; index < activeElements.length; index++) {
      if (!exclude.includes(activeElements[index]))
        zIndexes.push(getZIndex(activeElements[index]));
    }
    return Math.max(...zIndexes);
  };
  const activeZIndex = computed(() => {
    if (!content.value)
      return 0;
    const index = isActive.value ? getMaxZIndex([content.value]) + 2 : getZIndex(content.value);
    if (index === null)
      return 0;
    return index;
  });
  return {
    activeZIndex
  };
};
const useLazyActivation = (baseState) => {
  const activatedOnce = ref(false);
  const active = ref(false);
  const deactivating = ref(false);
  if (baseState.value) {
    activatedOnce.value = true;
    nextTick(() => {
      active.value = true;
    });
  }
  watch(() => baseState.value, (value) => {
    if (!value) {
      deactivating.value = true;
      nextTick(() => {
        active.value = value;
        deactivating.value = false;
      });
      return;
    }
    if (activatedOnce.value) {
      active.value = value;
      return;
    }
    activatedOnce.value = true;
    nextTick(() => {
      active.value = value;
    });
  });
  return {
    activatedOnce,
    active,
    deactivating
  };
};
const composedPath = (e) => {
  if (e.composedPath)
    return e.composedPath();
  const path = [];
  let el = e.target;
  while (el) {
    path.push(el);
    if (el.tagName === "HTML") {
      path.push(document);
      path.push(window);
      return path;
    }
    el = el.parentElement;
  }
  return path;
};
const hasScrollbar = (el) => {
  if (!el || el.nodeType !== Node.ELEMENT_NODE)
    return false;
  const style = window.getComputedStyle(el);
  return ["auto", "scroll"].includes(style.overflowY) && el.scrollHeight > el.clientHeight;
};
const shouldScroll = (el, delta) => {
  if (el.scrollTop === 0 && delta < 0)
    return true;
  return el.scrollTop + el.clientHeight === el.scrollHeight && delta > 0;
};
const noScrollableParent = (event, content) => {
  const path = composedPath(event);
  const delta = event.deltaY;
  for (let index = 0; index < path.length; index++) {
    const el = path[index];
    if (el === document)
      return true;
    if (el === document.documentElement)
      return true;
    if (el === content)
      return true;
    if (hasScrollbar(el))
      return shouldScroll(el, delta);
  }
  return true;
};
const getScrollbarWidth = () => {
  const container = document.createElement("div");
  container.style.visibility = "hidden";
  container.style.overflow = "scroll";
  const inner = document.createElement("div");
  container.appendChild(inner);
  document.body.appendChild(container);
  const scrollbarWidth = container.offsetWidth - inner.offsetWidth;
  document.body.removeChild(container);
  return scrollbarWidth;
};
const useScroll = ({
  overlay,
  content,
  contentActiveClass,
  fullscreen,
  contentFullscreenClass
}) => {
  let disabled = false;
  let disableType;
  const eventListener = (event) => {
    if (event.target === overlay.value || event.target === document.body || noScrollableParent(event, content.value))
      event.preventDefault();
  };
  const scrollbarWidth = getScrollbarWidth();
  const zeroScrollBar = scrollbarWidth === 0;
  const disableScroll = () => {
    if (disabled)
      return;
    if (zeroScrollBar || fullscreen) {
      disableType = "byOverflow";
      document.documentElement.classList.add("overflow-y-hidden");
    } else {
      disableType = "byEvents";
      window.addEventListener("wheel", eventListener, {
        passive: false
      });
    }
    disabled = true;
  };
  const enableScroll = () => {
    if (!disabled)
      return;
    if (disableType === "byEvents") {
      window.removeEventListener("wheel", eventListener);
    } else if (disableType === "byOverflow") {
      const activeContentElements = document.getElementsByClassName(contentActiveClass);
      const activeFullscreenContentElements = document.getElementsByClassName(contentFullscreenClass);
      if (!zeroScrollBar && fullscreen && activeFullscreenContentElements.length === 1 || activeContentElements.length === 1)
        document.documentElement.classList.remove("overflow-y-hidden");
    }
    disabled = false;
  };
  return {
    disableScroll,
    enableScroll
  };
};
var GDialogOverlay_vue_vue_type_style_index_0_lang = "";
var _export_sfc = (sfc, props) => {
  const target = sfc.__vccOpts || sfc;
  for (const [key, val] of props) {
    target[key] = val;
  }
  return target;
};
const __default__$1 = defineComponent({
  name: "GDialogOverlay",
  props: {
    active: {
      type: Boolean,
      required: true
    },
    activeZIndex: {
      type: Number,
      required: true
    },
    background: {
      type: [Boolean, String],
      required: true
    },
    deactivating: {
      type: Boolean,
      required: true
    },
    local: {
      type: Boolean,
      default: false
    }
  },
  emits: ["click"],
  setup(props, { emit }) {
    const styles = computed(() => ({
      zIndex: props.activeZIndex - 1
    }));
    const classes = computed(() => [
      "g-dialog-overlay",
      {
        "g-dialog-overlay--active": props.active && !props.deactivating,
        "g-dialog-overlay--local": props.local
      }
    ]);
    const computedBackground = computed(() => {
      if (typeof props.background === "string")
        return props.background;
      else if (props.background)
        return "var(--overlay-bg)";
      return "transparent";
    });
    const onClick = () => {
      emit("click");
    };
    return {
      styles,
      classes,
      computedBackground,
      onClick
    };
  }
});
const __injectCSSVars__$1 = () => {
  useCssVars((_ctx) => ({
    "5d65889e": _ctx.computedBackground
  }));
};
const __setup__$1 = __default__$1.setup;
__default__$1.setup = __setup__$1 ? (props, ctx) => {
  __injectCSSVars__$1();
  return __setup__$1(props, ctx);
} : __injectCSSVars__$1;
const _sfc_main$3 = __default__$1;
function _sfc_render$3(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock(Transition, { name: "fade" }, {
    default: withCtx(() => [
      _ctx.active ? (openBlock(), createElementBlock("div", {
        key: 0,
        class: normalizeClass(_ctx.classes),
        style: normalizeStyle(_ctx.styles),
        onClick: _cache[0] || (_cache[0] = (...args) => _ctx.onClick && _ctx.onClick(...args))
      }, null, 6)) : createCommentVNode("", true)
    ]),
    _: 1
  });
}
var GDialogOverlay = /* @__PURE__ */ _export_sfc(_sfc_main$3, [["render", _sfc_render$3]]);
const useSizeStyle = (props) => {
  const sizeStyles = computed(() => ({
    maxWidth: props.maxWidth === "none" ? void 0 : convertToUnit(props.maxWidth),
    width: props.width === "auto" ? void 0 : convertToUnit(props.width),
    height: props.height === "auto" ? void 0 : convertToUnit(props.height)
  }));
  return {
    sizeStyles
  };
};
var GDialogContent_vue_vue_type_style_index_0_lang = "";
const __default__ = defineComponent({
  name: "GDialogContent",
  props: {
    background: {
      type: [Boolean, String],
      required: true
    },
    borderRadius: {
      type: [Boolean, Number, String],
      required: true
    },
    class: {
      type: String,
      default: ""
    },
    depressed: {
      type: Boolean,
      default: false
    },
    fullscreen: {
      type: Boolean,
      default: false
    },
    height: {
      type: [String, Number],
      required: true
    },
    maxWidth: {
      type: [String, Number],
      default: "none"
    },
    scrollable: {
      type: Boolean,
      default: false
    },
    width: {
      type: [String, Number],
      default: "auto"
    }
  },
  setup(props) {
    const { sizeStyles: styles } = useSizeStyle(props);
    const classes = computed(() => [
      "g-dialog-content",
      props.class,
      {
        "g-dialog-content--scrollable": props.scrollable,
        "g-dialog-content--depressed": props.depressed,
        "g-dialog-content--fullscreen": props.fullscreen,
        "g-dialog-content--no-bg": props.background
      }
    ]);
    const computedBackground = computed(() => {
      if (typeof props.background === "string")
        return props.background;
      else if (props.background)
        return "var(--content-bg)";
      return "transparent";
    });
    const computedBorderRadius = computed(() => {
      if (typeof props.borderRadius === "string")
        return convertToUnit(props.borderRadius);
      else if (props.borderRadius)
        return "var(--content-border-radius)";
      return "0";
    });
    return {
      styles,
      classes,
      computedBackground,
      computedBorderRadius
    };
  }
});
const __injectCSSVars__ = () => {
  useCssVars((_ctx) => ({
    "8218b24e": _ctx.computedBackground,
    "35388ec9": _ctx.computedBorderRadius
  }));
};
const __setup__ = __default__.setup;
__default__.setup = __setup__ ? (props, ctx) => {
  __injectCSSVars__();
  return __setup__(props, ctx);
} : __injectCSSVars__;
const _sfc_main$2 = __default__;
function _sfc_render$2(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", {
    class: normalizeClass(_ctx.classes),
    style: normalizeStyle(_ctx.styles)
  }, [
    renderSlot(_ctx.$slots, "default")
  ], 6);
}
var GDialogContent = /* @__PURE__ */ _export_sfc(_sfc_main$2, [["render", _sfc_render$2]]);
var GDialog_vue_vue_type_style_index_0_lang = "";
const _sfc_main$1 = defineComponent({
  name: "GDialog",
  components: {
    GDialogOverlay,
    GDialogContent
  },
  inheritAttrs: false,
  props: {
    background: {
      type: [Boolean, String],
      default: true
    },
    borderRadius: {
      type: [Boolean, Number, String],
      default: true
    },
    contentClass: {
      type: String,
      default: ""
    },
    depressed: {
      type: Boolean,
      default: false
    },
    fullscreen: {
      type: Boolean,
      default: false
    },
    height: {
      type: [String, Number],
      default: "auto"
    },
    local: {
      type: Boolean,
      default: false
    },
    maxWidth: {
      type: [String, Number],
      default: "none"
    },
    modelValue: {
      type: Boolean,
      default: false
    },
    overlayBackground: {
      type: [Boolean, String],
      default: true
    },
    persistent: {
      type: Boolean,
      default: false
    },
    scrollable: {
      type: Boolean,
      default: false
    },
    transition: {
      type: String,
      default: "g-dialog-transition"
    },
    width: {
      type: [String, Number],
      default: "auto"
    }
  },
  emits: {
    "update:modelValue": (val) => true
  },
  setup(props, { emit }) {
    const contentFrame = ref();
    const overlay = ref();
    const overlayElement = computed(() => {
      var _a;
      return (_a = overlay.value) == null ? void 0 : _a.$el;
    });
    const scopedModelValue = ref(props.modelValue);
    watch(() => props.modelValue, (val) => {
      scopedModelValue.value = val;
    });
    const onClose = () => {
      scopedModelValue.value = false;
      emit("update:modelValue", false);
    };
    const onOpen = () => {
      scopedModelValue.value = true;
      emit("update:modelValue", true);
    };
    const { activatedOnce, active: isActive, deactivating } = useLazyActivation(computed(() => scopedModelValue.value));
    const { activeZIndex } = useStackable({
      activeElSelector: ".g-dialog-frame--active",
      stackMinZIndex: 200,
      isActive,
      content: contentFrame
    });
    const classes = computed(() => [
      "g-dialog-frame",
      {
        "g-dialog-frame--active": isActive.value,
        "g-dialog-frame--fullscreen": props.fullscreen,
        "g-dialog-frame--local": props.local
      }
    ]);
    const styles = computed(() => ({
      zIndex: activeZIndex.value
    }));
    const { enableScroll, disableScroll } = useScroll({
      overlay: overlayElement,
      content: contentFrame,
      contentActiveClass: "g-dialog-frame--active",
      fullscreen: props.fullscreen,
      contentFullscreenClass: "g-dialog-frame--fullscreen"
    });
    watch(isActive, (active) => {
      if (props.local)
        return;
      if (active)
        disableScroll();
      else
        enableScroll();
    });
    onBeforeUnmount(() => {
      enableScroll();
    });
    const onClickOutside = () => {
      if (!props.persistent)
        onClose();
    };
    const activatorAttrs = {
      onClick() {
        onOpen();
      }
    };
    return {
      activatedOnce,
      activeZIndex,
      isActive,
      deactivating,
      classes,
      styles,
      contentFrame,
      overlay,
      activatorAttrs,
      onClickOutside,
      onClose
    };
  }
});
function _sfc_render$1(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_GDialogOverlay = resolveComponent("GDialogOverlay");
  const _component_GDialogContent = resolveComponent("GDialogContent");
  return openBlock(), createElementBlock(Fragment, null, [
    renderSlot(_ctx.$slots, "activator", normalizeProps(guardReactiveProps(_ctx.activatorAttrs))),
    _ctx.activatedOnce ? (openBlock(), createElementBlock(Fragment, { key: 0 }, [
      (openBlock(), createBlock(Teleport, {
        to: "body",
        disabled: _ctx.local
      }, [
        !_ctx.fullscreen ? (openBlock(), createBlock(_component_GDialogOverlay, {
          key: 0,
          ref: "overlay",
          active: _ctx.isActive,
          "active-z-index": _ctx.activeZIndex,
          background: _ctx.overlayBackground,
          deactivating: _ctx.deactivating,
          local: _ctx.local,
          onClick: _ctx.onClickOutside
        }, null, 8, ["active", "active-z-index", "background", "deactivating", "local", "onClick"])) : createCommentVNode("", true)
      ], 8, ["disabled"])),
      (openBlock(), createBlock(Teleport, {
        to: "body",
        disabled: _ctx.local
      }, [
        createVNode(Transition, { name: _ctx.transition }, {
          default: withCtx(() => [
            withDirectives(createElementVNode("div", {
              ref: "contentFrame",
              class: normalizeClass(_ctx.classes),
              style: normalizeStyle(_ctx.styles)
            }, [
              createVNode(_component_GDialogContent, {
                class: normalizeClass(_ctx.contentClass),
                "max-width": _ctx.maxWidth,
                width: _ctx.width,
                height: _ctx.height,
                scrollable: _ctx.scrollable,
                depressed: _ctx.depressed,
                fullscreen: _ctx.fullscreen,
                background: _ctx.background,
                "border-radius": _ctx.borderRadius
              }, {
                default: withCtx(() => [
                  renderSlot(_ctx.$slots, "default", { onClose: _ctx.onClose })
                ]),
                _: 3
              }, 8, ["class", "max-width", "width", "height", "scrollable", "depressed", "fullscreen", "background", "border-radius"])
            ], 6), [
              [vShow, _ctx.isActive]
            ])
          ]),
          _: 3
        }, 8, ["name"])
      ], 8, ["disabled"]))
    ], 64)) : createCommentVNode("", true)
  ], 64);
}
var GDialog = /* @__PURE__ */ _export_sfc(_sfc_main$1, [["render", _sfc_render$1]]);
const dialogs = shallowReactive([]);
const $dialog = {
  dialogs,
  addDialog: ({ component, props }) => {
    dialogs.push({
      component,
      id: Date.now() + Math.random(),
      props: __spreadValues({
        modelValue: true
      }, props)
    });
  },
  removeDialog: (index) => {
    const dialog = dialogs[index];
    dialog.props.modelValue = false;
    setTimeout(() => {
      dialogs.splice(index, 1);
    }, 150);
  }
};
const errorLogger = {
  pluginIsNotInitialized() {
    console.error("The gitart-vue-dialog plugin is not initialized. Read how to solve: https://gitart-vue-dialog.netlify.app/docs/guide/plugin-usage.html#usage");
  }
};
const dialogInjectionKey = Symbol("GDialog");
const dialogInjectionFallback = {
  dialogs: [],
  addDialog: () => {
    errorLogger.pluginIsNotInitialized();
  },
  removeDialog: () => {
    errorLogger.pluginIsNotInitialized();
  }
};
const plugin = {
  install: (app) => {
    app.provide(dialogInjectionKey, $dialog);
    app.config.globalProperties.$dialog = $dialog;
  }
};
const _sfc_main = defineComponent({
  name: "GDialogRoot",
  setup() {
    const {
      dialogs: dialogs2,
      removeDialog
    } = inject(dialogInjectionKey, dialogInjectionFallback);
    if (dialogs2 === dialogInjectionFallback.dialogs)
      errorLogger.pluginIsNotInitialized();
    function onClose(index) {
      removeDialog(index);
    }
    return {
      dialogs: dialogs2,
      onClose
    };
  }
});
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(true), createElementBlock(Fragment, null, renderList(_ctx.dialogs, (dialog, index) => {
    return openBlock(), createBlock(resolveDynamicComponent(dialog.component), mergeProps({
      key: dialog.id
    }, dialog.props, {
      "onUpdate:modelValue": ($event) => _ctx.onClose(index)
    }), null, 16, ["onUpdate:modelValue"]);
  }), 128);
}
var GDialogRoot = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export { GDialog, GDialogRoot, dialogInjectionKey, plugin };
